Index: /NEMO/trunk/doc/rst/Makefile
===================================================================
--- /NEMO/trunk/doc/rst/Makefile	(revision 10989)
+++ /NEMO/trunk/doc/rst/Makefile	(revision 10990)
@@ -23,3 +23,3 @@
 # Browse to 127.0.0.1:8000/NEMO_guide.html
 htmllive:
-	sphinx-autobuild $(SPHINXOPTS) $(SOURCEDIR) $(BUILDDIR)/html
+	sphinx-autobuild $(SPHINXOPTS) $(SOURCEDIR) $(BUILDDIR)/htmllive
Index: /NEMO/trunk/doc/rst/README.rst
===================================================================
--- /NEMO/trunk/doc/rst/README.rst	(revision 10990)
+++ /NEMO/trunk/doc/rst/README.rst	(revision 10990)
@@ -0,0 +1,54 @@
+**********************
+NEMO Quick Start Guide
+**********************
+
+| The NEMO guide is made up of several files written in `ReStructuredText <http://docutils.sourceforge.net/rst.html>`_ (`.rst` extension), a WYSIWYG markup language used in the Python community, and scattered all over the NEMO sources.
+| You can view them one by one in plain text from `./source` folder, or export all to a user-friendly guide under `./build` (only HTML format at the moment, PDF expected later).
+
+Build and export the guide in HTML
+==================================
+
+1.  Install Sphinx documentation generator, its BibTeX extension and "Read The Docs" theme thanks to `pip` packages tool
+
+    .. code-block:: console
+
+        $ pip install sphinx sphinxcontrib.bibtex sphinx_rtd_theme
+
+2.  Build the HTML export with `make` in `./build/html`
+
+    .. code-block:: console
+
+        $ make html
+
+3.  Finally browse the guide by opening `./build/html/NEMO_guide.html`
+
+
+Edit the sources and check the output in real time
+==================================================
+
+| To facilitate the update of the guide, editors can install a useful package that will automatically trigger a new build and the reload of the HTML page for every recorded change in the sources.
+| So the reviewer saves time by controlling on-line their modifications almost as it types and also by avoiding repeated interactive rebuilds.
+
+Install `sphinx-autobuild` package
+
+.. code-block:: console
+
+	$ pip install sphinx-autobuild
+
+Launch a local web server hosting a draft export of the guide (build this time in `./build/livehtml`)
+
+.. code-block:: console
+
+    $ make livehtml
+
+| In the same time, open the 2 formats of the content to review: the source file and the web page by browsing from `the new guide hosted by your local server <127.0.0.1:8000/NEMO_guide.html>`_.
+| Start the update, save your changes and verify instantly the HTML export in your browser.
+
+.. warning::
+
+    | Your modifications are not taken into account?
+    | For symlink file, you will have to close it to update the HTML export. Otherwise look at the log of the Sphinx build, you probably made a typo!
+
+.. hint::
+
+    Are there broken links? Fix "Page not found" errors by running `make linkcheck`
Index: MO/trunk/doc/rst/requirements_make_html.txt
===================================================================
--- /NEMO/trunk/doc/rst/requirements_make_html.txt	(revision 10989)
+++ 	(revision )
@@ -1,26 +1,0 @@
-alabaster==0.7.12
-Babel==2.6.0
-certifi==2018.11.29
-chardet==3.0.4
-docutils==0.14
-idna==2.8
-imagesize==1.1.0
-Jinja2==2.10
-latexcodec==1.0.6
-MarkupSafe==1.1.0
-oset==0.1.3
-packaging==19.0
-pybtex==0.22.2
-pybtex-docutils==0.2.1
-Pygments==2.3.1
-pyparsing==2.3.1
-pytz==2018.9
-PyYAML==3.13
-requests==2.21.0
-six==1.12.0
-snowballstemmer==1.2.1
-Sphinx==1.8.3
-sphinx-rtd-theme==0.4.2
-sphinxcontrib-bibtex==0.4.2
-sphinxcontrib-websupport==1.1.0
-urllib3==1.24.1
Index: MO/trunk/doc/rst/requirements_make_htmllive.txt
===================================================================
--- /NEMO/trunk/doc/rst/requirements_make_htmllive.txt	(revision 10989)
+++ 	(revision )
@@ -1,7 +1,0 @@
-argh==0.26.2
-livereload==2.6.0
-pathtools==0.1.2
-port-for==0.3.1
-sphinx-autobuild==0.7.1
-tornado==5.1.1
-watchdog==0.9.0
Index: /NEMO/trunk/doc/rst/source/conf.py
===================================================================
--- /NEMO/trunk/doc/rst/source/conf.py	(revision 10989)
+++ /NEMO/trunk/doc/rst/source/conf.py	(revision 10990)
@@ -112,4 +112,4 @@
 # SVN revision
 import subprocess
-revision = subprocess.check_output("svnversion")
+revision = subprocess.check_output("svnversion").decode("utf-8")
 rst_prolog = '.. |svn_revision| replace:: %s' % revision