Index: /NEMO/releases/release-4.0/INSTALL.rst
===================================================================
--- /NEMO/releases/release-4.0/INSTALL.rst	(revision 10991)
+++ /NEMO/releases/release-4.0/INSTALL.rst	(revision 10992)
@@ -104,5 +104,5 @@
    .. code:: console
 
-      $ svn co http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/branchs/xios-2.5
+      $ svn co https://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/branchs/xios-2.5
 
 Download the NEMO source code
@@ -111,5 +111,5 @@
 .. code:: console
 
-   $ svn co http://forge.ipsl.jussieu.fr/nemo/svn/NEMO/releases/release-4.0
+   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/releases/release-4.0
 
 Description of directory tree
Index: /NEMO/releases/release-4.0/README.rst
===================================================================
--- /NEMO/releases/release-4.0/README.rst	(revision 10991)
+++ /NEMO/releases/release-4.0/README.rst	(revision 10992)
@@ -1,4 +1,5 @@
-:Release: |version|
-:Date:    |today|
+:Release:  |release|
+:Date:     |today|
+:SVN rev.: |revision|
 
 NEMO_ for **Nucleus for European Modelling of the Ocean** is a state-of-the-art modelling framework for
@@ -90,8 +91,8 @@
 .. Substitutions / Links
 
-.. |NEMO manual| image:: http://zenodo.org/badge/DOI/10.5281/zenodo.1464816.svg
-.. |NEMO guide|  image:: http://zenodo.org/badge/DOI/10.5281/zenodo.1475325.svg
-.. |SI3 manual|  image:: http://zenodo.org/badge/DOI/10.5281/zenodo.1471689.svg
-.. |TOP manual|  image:: http://zenodo.org/badge/DOI/10.5281/zenodo.1471700.svg
+.. |NEMO manual| image:: https://zenodo.org/badge/DOI/10.5281/zenodo.1464816.svg
+.. |NEMO guide|  image:: https://zenodo.org/badge/DOI/10.5281/zenodo.1475325.svg
+.. |SI3 manual|  image:: https://zenodo.org/badge/DOI/10.5281/zenodo.1471689.svg
+.. |TOP manual|  image:: https://zenodo.org/badge/DOI/10.5281/zenodo.1471700.svg
 
 .. |NEMO strategy| replace:: multi-year development strategy
Index: /NEMO/releases/release-4.0/cfgs/README.rst
===================================================================
--- /NEMO/releases/release-4.0/cfgs/README.rst	(revision 10991)
+++ /NEMO/releases/release-4.0/cfgs/README.rst	(revision 10992)
@@ -235,5 +235,5 @@
 .. literalinclude:: ../../../cfgs/GYRE_PISCES/EXPREF/namelist_ref
    :language: fortran
-   :lines: 306-333
+   :lines: 935-960
 
 Input dynamical fields for this configuration (``ORCA2_OFF_v4.0.tar``) comes from
Index: /NEMO/releases/release-4.0/doc/rst/Makefile
===================================================================
--- /NEMO/releases/release-4.0/doc/rst/Makefile	(revision 10991)
+++ /NEMO/releases/release-4.0/doc/rst/Makefile	(revision 10992)
@@ -23,3 +23,3 @@
 # Browse to 127.0.0.1:8000/NEMO_guide.html
 htmllive:
-	sphinx-autobuild $(SPHINXOPTS) $(SOURCEDIR) $(BUILDDIR)/html
+	sphinx-autobuild $(SPHINXOPTS) $(SOURCEDIR) $(BUILDDIR)/htmllive
Index: /NEMO/releases/release-4.0/doc/rst/README.rst
===================================================================
--- /NEMO/releases/release-4.0/doc/rst/README.rst	(revision 10992)
+++ /NEMO/releases/release-4.0/doc/rst/README.rst	(revision 10992)
@@ -0,0 +1,54 @@
+**********************
+NEMO Quick Start Guide
+**********************
+
+| The NEMO guide is made up of several files written in `ReStructuredText <http://docutils.sourceforge.net/rst.html>`_ (`.rst` extension), a WYSIWYG markup language used in the Python community, and scattered all over the NEMO sources.
+| You can view them one by one in plain text from `./source` folder, or export all to a user-friendly guide under `./build` (only HTML format at the moment, PDF expected later).
+
+Build and export the guide in HTML
+==================================
+
+1.  Install Sphinx documentation generator, its BibTeX extension and "Read The Docs" theme thanks to `pip` packages tool
+
+    .. code-block:: console
+
+        $ pip install sphinx sphinxcontrib.bibtex sphinx_rtd_theme
+
+2.  Build the HTML export with `make` in `./build/html`
+
+    .. code-block:: console
+
+        $ make html
+
+3.  Finally browse the guide by opening `./build/html/NEMO_guide.html`
+
+
+Edit the sources and check the output in real time
+==================================================
+
+| To facilitate the update of the guide, editors can install a useful package that will automatically trigger a new build and the reload of the HTML page for every recorded change in the sources.
+| So the reviewer saves time by controlling on-line their modifications almost as it types and also by avoiding repeated interactive rebuilds.
+
+Install `sphinx-autobuild` package
+
+.. code-block:: console
+
+	$ pip install sphinx-autobuild
+
+Launch a local web server hosting a draft export of the guide (build this time in `./build/livehtml`)
+
+.. code-block:: console
+
+    $ make livehtml
+
+| Open in the same time the 2 formats of the content to review: the source file and the web page by browsing from the new guide hosted by your local server on `<http://127.0.0.1:8000/NEMO_guide.html>`_.
+| Start the update, save your changes and verify instantly the HTML export in your browser.
+
+.. warning::
+
+    | Your modifications are not taken into account?
+    | For symlink file, you will have to close it to update the HTML export. Otherwise look at the log of the Sphinx build, you probably made a typo!
+
+.. hint::
+
+    Are there broken links? Fix "Page not found" errors by running `make linkcheck`
Index: MO/releases/release-4.0/doc/rst/requirements.txt
===================================================================
--- /NEMO/releases/release-4.0/doc/rst/requirements.txt	(revision 10991)
+++ 	(revision )
@@ -1,52 +1,0 @@
-alabaster==0.7.12
-Babel==2.6.0
-Brlapi==0.6.5
-certifi==2018.11.29
-chardet==3.0.4
-cryptography==1.7.1
-cupshelpers==1.0
-docutils==0.14
-httplib2==0.9.2
-idna==2.8
-imagesize==1.1.0
-Jinja2==2.10
-keyring==10.1
-keyrings.alt==1.3
-latexcodec==1.0.5
-louis==3.0.0
-Mako==1.0.6
-MarkupSafe==1.1.0
-oset==0.1.3
-packaging==18.0
-pexpect==4.2.1
-Pillow==4.0.0
-ptyprocess==0.5.1
-pyasn1==0.1.9
-pybtex==0.22.2
-pybtex-docutils==0.2.1
-pycrypto==2.6.1
-pycups==1.9.73
-pycurl==7.43.0
-Pygments==2.3.1
-pygobject==3.22.0
-pyparsing==2.3.1
-pysmbc==1.0.15.6
-python-apt==1.4.0b3
-python-debian==0.1.30
-python-debianbts==2.6.1
-pytz==2018.9
-pyxdg==0.25
-PyYAML==3.13
-reportbug==7.1.7
-reportlab==3.3.0
-requests==2.21.0
-roman==2.0.0
-SecretStorage==2.3.1
-six==1.12.0
-snowballstemmer==1.2.1
-Sphinx==1.8.3
-sphinx-rtd-theme==0.4.2
-sphinxcontrib-bibtex==0.4.2
-sphinxcontrib-websupport==1.1.0
-unattended-upgrades==0.1
-urllib3==1.24.1
Index: /NEMO/releases/release-4.0/doc/rst/source/_templates/layout.html
===================================================================
--- /NEMO/releases/release-4.0/doc/rst/source/_templates/layout.html	(revision 10991)
+++ /NEMO/releases/release-4.0/doc/rst/source/_templates/layout.html	(revision 10992)
@@ -12,5 +12,5 @@
 	<p>Community ocean model for multifarious space and time scales</p>
 
-	<div class="version">{{ release }}</div>
+	<div class="version">{{ version }}</div>
 
 	{% include "searchbox.html" %}
Index: /NEMO/releases/release-4.0/doc/rst/source/conf.py
===================================================================
--- /NEMO/releases/release-4.0/doc/rst/source/conf.py	(revision 10991)
+++ /NEMO/releases/release-4.0/doc/rst/source/conf.py	(revision 10992)
@@ -92,4 +92,5 @@
 # -- Customisation -----------------------------------------------------------
 
+# Timestamping
 import datetime
 year = datetime.date.today().year
@@ -108,2 +109,7 @@
 # Include common directives for every rst file
 rst_epilog = open('global.rst', 'r').read()
+
+# SVN revision
+import subprocess
+revision = subprocess.check_output("svnversion").decode("utf-8")
+rst_prolog = '.. |revision| replace:: %s' % revision