Index: /NEMO/trunk/doc/namelists/nambdy
===================================================================
--- /NEMO/trunk/doc/namelists/nambdy	(revision 11004)
+++ /NEMO/trunk/doc/namelists/nambdy	(revision 11005)
@@ -3,42 +3,34 @@
 !-----------------------------------------------------------------------
    ln_bdy         = .false.   !  Use unstructured open boundaries
-   nb_bdy         = 2         !  number of open boundary sets
-   ln_coords_file = .true. , .false.    !  =T : read bdy coordinates from file
+   nb_bdy         = 0         !  number of open boundary sets
+   ln_coords_file = .true.    !  =T : read bdy coordinates from file
       cn_coords_file = 'coordinates.bdy.nc'  !  bdy coordinates files
    ln_mask_file   = .false.   !  =T : read mask from file
-      cn_mask_file = ''       !  name of mask file (if ln_mask_file=.TRUE.)
-   cn_dyn2d    = 'flather', 'none'       !
-   nn_dyn2d_dta   =  3 , 0    !  = 0, bdy data are equal to the initial state
+      cn_mask_file = ''        !  name of mask file (if ln_mask_file=.TRUE.)
+   cn_dyn2d    = 'none'       !
+   nn_dyn2d_dta   =  0        !  = 0, bdy data are equal to the initial state
       !                       !  = 1, bdy data are read in 'bdydata   .nc' files
       !                       !  = 2, use tidal harmonic forcing data from files
       !                       !  = 3, use external data AND tidal harmonic forcing
-   cn_dyn3d      =  'none' , 'none'
-   nn_dyn3d_dta  =  0 , 0     !  = 0, bdy data are equal to the initial state
+   cn_dyn3d      =  'none'    !
+   nn_dyn3d_dta  =  0         !  = 0, bdy data are equal to the initial state
    !                          !  = 1, bdy data are read in 'bdydata   .nc' files
-   cn_tra        =  'frs' , 'frs'
-   nn_tra_dta    =  1 , 0     !  = 0, bdy data are equal to the initial state
+   cn_tra        =  'none'    !
+   nn_tra_dta    =  0         !  = 0, bdy data are equal to the initial state
    !                          !  = 1, bdy data are read in 'bdydata   .nc' files
-   cn_ice        =  'none' , 'none'
-   nn_ice_dta    =  0, 0      !  = 0, bdy data are equal to the initial state
+   cn_ice        =  'none'    !
+   nn_ice_dta    =  0         !  = 0, bdy data are equal to the initial state
    !                          !  = 1, bdy data are read in 'bdydata   .nc' files
-   rn_ice_tem    = 270., 270. !  si3 only: arbitrary temperature of incoming sea ice
-   rn_ice_sal    = 10. ,  10. !  si3 only:      --   salinity           --
-   rn_ice_age    = 30. ,  30. !  si3 only:      --   age                --
+   rn_ice_tem    = 270.       !  si3 only: arbitrary temperature of incoming sea ice
+   rn_ice_sal    = 10.        !  si3 only:      --   salinity           --
+   rn_ice_age    = 30.        !  si3 only:      --   age                --
    !
-   ln_tra_dmp    =.false., .false.  !  open boudaries conditions for tracers
-   ln_dyn3d_dmp  =.false., .false.  !  open boundary condition for baroclinic velocities
-   rn_time_dmp   =  1., 1.    !  Damping time scale in days
-   rn_time_dmp_out = 1., 1.    !  Outflow damping time scale
-   nn_rimwidth   = 10, 5      !  width of the relaxation zone
+   ln_tra_dmp    =.false.     !  open boudaries conditions for tracers
+   ln_dyn3d_dmp  =.false.     !  open boundary condition for baroclinic velocities
+   rn_time_dmp   =  1.        !  Damping time scale in days
+   rn_time_dmp_out = 1.        !  Outflow damping time scale
+   nn_rimwidth   = 10         !  width of the relaxation zone
    ln_vol        = .false.    !  total volume correction (see nn_volctl parameter)
    nn_volctl     =  1         !  = 0, the total water flux across open boundaries is zero
    nb_jpk_bdy    = -1         ! number of levels in the bdy data (set < 0 if consistent with planned run)
 /
-!-----------------------------------------------------------------------
-&nambdy_index     ! index definition of bdy
-!-----------------------------------------------------------------------
-    ctypebdy = 'S'
-    nbdyind  =  2
-    nbdybeg  = 2
-    nbdyend  = 273
-/
Index: /NEMO/trunk/doc/namelists/namberg
===================================================================
--- /NEMO/trunk/doc/namelists/namberg	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namberg	(revision 11005)
@@ -5,31 +5,31 @@
    !
    !                          ! diagnostics:
-   ln_bergdia        = .true.       ! Calculate budgets
-   nn_verbose_level  = 1            ! Turn on more verbose output if level > 0
-   nn_verbose_write  = 15           ! Timesteps between verbose messages
-   nn_sample_rate    = 1            ! Timesteps between sampling for trajectory storage
+   ln_bergdia        = .true.        ! Calculate budgets
+   nn_verbose_level  = 0             ! Turn on more verbose output if level > 0
+   nn_verbose_write  = 15            ! Timesteps between verbose messages
+   nn_sample_rate    = 1             ! Timesteps between sampling for trajectory storage
    !
    !                          ! iceberg setting:
-   !                                ! Initial mass required for an iceberg of each class
+   !                                 ! Initial mass required for an iceberg of each class
    rn_initial_mass   = 8.8e7, 4.1e8, 3.3e9, 1.8e10, 3.8e10, 7.5e10, 1.2e11, 2.2e11, 3.9e11, 7.4e11
-   !                                ! Proportion of calving mass to apportion to each class
+   !                                 ! Proportion of calving mass to apportion to each class
    rn_distribution   = 0.24, 0.12, 0.15, 0.18, 0.12, 0.07, 0.03, 0.03, 0.03, 0.02
-   !                                ! Ratio between effective and real iceberg mass (non-dim)
-   !                                ! i.e. number of icebergs represented at a point
-   rn_mass_scaling   = 2000, 200, 50, 20, 10, 5, 2, 1, 1, 1
-                                    ! thickness of newly calved bergs (m)
+   !                                 ! Ratio between effective and real iceberg mass (non-dim)
+   !                                 ! i.e. number of icebergs represented at a point
+   rn_mass_scaling   = 2000., 200., 50., 20., 10., 5., 2., 1., 1., 1.
+                                     ! thickness of newly calved bergs (m)
    rn_initial_thickness     = 40., 67., 133., 175., 250., 250., 250., 250., 250., 250.
    !
-   rn_rho_bergs            = 850.   ! Density of icebergs
-   rn_LoW_ratio            = 1.5    ! Initial ratio L/W for newly calved icebergs
-   ln_operator_splitting   = .true. ! Use first order operator splitting for thermodynamics
-   rn_bits_erosion_fraction = 0.    ! Fraction of erosion melt flux to divert to bergy bits
-   rn_sicn_shift           = 0.     ! Shift of sea-ice concn in erosion flux (0<sicn_shift<1)
-   ln_passive_mode         = .false.! iceberg - ocean decoupling
-   nn_test_icebergs        =  10    ! Create test icebergs of this class (-1 = no)
-   !                                ! Put a test iceberg at each gridpoint in box (lon1,lon2,lat1,lat2)
+   rn_rho_bergs            = 850.    ! Density of icebergs
+   rn_LoW_ratio            = 1.5     ! Initial ratio L/W for newly calved icebergs
+   ln_operator_splitting   = .true.  ! Use first order operator splitting for thermodynamics
+   rn_bits_erosion_fraction = 0.     ! Fraction of erosion melt flux to divert to bergy bits
+   rn_sicn_shift           = 0.      ! Shift of sea-ice concn in erosion flux (0<sicn_shift<1)
+   ln_passive_mode         = .false. ! iceberg - ocean decoupling
+   nn_test_icebergs        =  10     ! Create test icebergs of this class (-1 = no)
+   !                                 ! Put a test iceberg at each gridpoint in box (lon1,lon2,lat1,lat2)
    rn_test_box             = 108.0,  116.0, -66.0, -58.0
-   ln_use_calving          = .false.! Use calving data even when nn_test_icebergs > 0
-   rn_speed_limit          = 0.     ! CFL speed limit for a berg
+   ln_use_calving          = .false. ! Use calving data even when nn_test_icebergs > 0
+   rn_speed_limit          = 0.      ! CFL speed limit for a berg
 
    cn_dir      = './'      !  root directory for the calving data location
Index: /NEMO/trunk/doc/namelists/namdom
===================================================================
--- /NEMO/trunk/doc/namelists/namdom	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namdom	(revision 11005)
@@ -5,5 +5,5 @@
    rn_isfhmin  =    1.00   !  treshold [m] to discriminate grounding ice from floating ice
    !
-   rn_rdt      = 5760.     !  time step for the dynamics and tracer
+   rn_rdt      = 5400.     !  time step for the dynamics and tracer
    rn_atfp     =    0.1    !  asselin time filter parameter
    !
Index: /NEMO/trunk/doc/namelists/namdyn
===================================================================
--- /NEMO/trunk/doc/namelists/namdyn	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namdyn	(revision 11005)
@@ -17,4 +17,4 @@
                                       !          recommended range: ?? L16=15 - home=10
       rn_lfrelax    =   1.e-5         !        relaxation time scale to reach static friction [s-1]
-      rn_tensile    =   0.2           !        isotropic tensile strength
+      rn_tensile    =   0.2           !        ln_landfast_L16: isotropic tensile strength
 /
Index: /NEMO/trunk/doc/namelists/namdyn_rhg
===================================================================
--- /NEMO/trunk/doc/namelists/namdyn_rhg	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namdyn_rhg	(revision 11005)
@@ -3,5 +3,5 @@
 !------------------------------------------------------------------------------
    ln_rhg_EVP       = .true.          !  EVP rheology
-      ln_aEVP       = .true.          !     adaptive rheology (Kimmritz et al. 2016 & 2017)
+      ln_aEVP       = .false.         !     adaptive rheology (Kimmritz et al. 2016 & 2017)
       rn_creepl     =   2.0e-9        !     creep limit [1/s]
       rn_ecc        =   2.0           !     eccentricity of the elliptical yield curve          
Index: /NEMO/trunk/doc/namelists/namdyn_vor
===================================================================
--- /NEMO/trunk/doc/namelists/namdyn_vor	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namdyn_vor	(revision 11005)
@@ -8,5 +8,5 @@
    ln_dynvor_eeT = .false. !  energy conserving scheme (een using e3t)
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 1          ! =0  e3f = mi(mj(e3t))/4 
+      nn_een_e3f = 0          ! =0  e3f = mi(mj(e3t))/4 
       !                       ! =1  e3f = mi(mj(e3t))/mi(mj( tmask))
    ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T)        ==>>> PLEASE DO NOT ACTIVATE
Index: MO/trunk/doc/namelists/namforcing
===================================================================
--- /NEMO/trunk/doc/namelists/namforcing	(revision 11004)
+++ 	(revision )
@@ -1,13 +1,0 @@
-!------------------------------------------------------------------------------
-&namforcing     !   Ice surface forcing
-!------------------------------------------------------------------------------
-   rn_cio           =   5.0e-03       !  ice-ocean drag coefficient (-)
-   rn_blow_s        =   0.66          !  mesure of snow blowing into the leads
-                                      !     = 1 => no snow blowing, < 1 => some snow blowing
-   nn_flxdist       =  -1             !  Redistribute heat flux over ice categories
-                                      !     =-1  Do nothing (needs N(cat) fluxes)
-                                      !     = 0  Average N(cat) fluxes then apply the average over the N(cat) ice
-                                      !     = 1  Average N(cat) fluxes then redistribute over the N(cat) ice using T-ice and albedo sensitivity
-                                      !     = 2  Redistribute a single flux over categories
-   nice_jules       = 0               !  Jules coupling (0=OFF, 1=EMULATED, 2=ACTIVE)
-/
Index: /NEMO/trunk/doc/namelists/namobs
===================================================================
--- /NEMO/trunk/doc/namelists/namobs	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namobs	(revision 11005)
@@ -19,4 +19,5 @@
    ln_s_at_t   = .false.             ! Logical switch for computing model S at T obs if not there
    ln_sstnight = .false.             ! Logical switch for calculating night-time average for SST obs
+   ln_bound_reject  = .false.        ! Logical to remove obs near boundaries in LAMs.
    ln_sla_fp_indegs = .true.         ! Logical for SLA: T=> averaging footprint is in degrees, F=> in metres
    ln_sst_fp_indegs = .true.         ! Logical for SST: T=> averaging footprint is in degrees, F=> in metres
Index: /NEMO/trunk/doc/namelists/nampar
===================================================================
--- /NEMO/trunk/doc/namelists/nampar	(revision 11004)
+++ /NEMO/trunk/doc/namelists/nampar	(revision 11005)
@@ -5,7 +5,6 @@
    nlay_i           =   2             !  number of ice  layers
    nlay_s           =   1             !  number of snow layers (only 1 is working)
-   nn_virtual_itd   =   0             !  virtual ITD mono-category parameterizations (1-3 => jpl = 1 only) or not (0)
-                                      !     2: activate enhanced thermal conductivity only --- temporary option
-                                      !     3: activate virtual thin ice melting only      ---  temporary option
+   ln_virtual_itd   =   .false.       !  virtual ITD mono-category parameterization (jpl=1 only)
+                                      !     i.e. enhanced thermal conductivity & virtual thin ice melting
    ln_icedyn        = .true.          !  ice dynamics (T) or not (F)
    ln_icethd        = .true.          !  ice thermo   (T) or not (F)
Index: /NEMO/trunk/doc/namelists/nampisfer
===================================================================
--- /NEMO/trunk/doc/namelists/nampisfer	(revision 11004)
+++ /NEMO/trunk/doc/namelists/nampisfer	(revision 11005)
@@ -2,5 +2,5 @@
 &nampisfer     !   parameters for iron chemistry
 !-----------------------------------------------------------------------
-   ln_ligvar =  .true.    ! variable ligand concentration
+   ln_ligvar =  .false.    ! variable ligand concentration
    xlam1     =  0.005     ! scavenging rate of Iron
    xlamdust  =  150.0     ! Scavenging rate of dust
Index: /NEMO/trunk/doc/namelists/namrun
===================================================================
--- /NEMO/trunk/doc/namelists/namrun	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namrun	(revision 11005)
@@ -5,5 +5,5 @@
    cn_exp      =  "ORCA2"  !  experience name
    nn_it000    =       1   !  first time step
-   nn_itend    =    5475   !  last  time step (std 5475)
+   nn_itend    =    5840   !  last  time step (std 5840)
    nn_date0    =  010101   !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_time0    =       0   !  initial time of day in hhmm
@@ -22,7 +22,7 @@
    nn_istate   =       0   !  output the initial state (1) or not (0)
    ln_rst_list = .false.   !  output restarts at list of times using nn_stocklist (T) or at set frequency with nn_stock (F)
-   nn_stock    =    5475   !  frequency of creation of a restart file (modulo referenced to 1)
+   nn_stock    =    5840   !  frequency of creation of a restart file (modulo referenced to 1)
    nn_stocklist = 0,0,0,0,0,0,0,0,0,0 ! List of timesteps when a restart file is to be written
-   nn_write    =    5475   !  frequency of write in the output file   (modulo referenced to nn_it000)
+   nn_write    =    5840   !  frequency of write in the output file   (modulo referenced to nn_it000)
    ln_mskland  = .false.   !  mask land points in NetCDF outputs (costly: + ~15%)
    ln_cfmeta   = .false.   !  output additional data to netCDF files required for compliance with the CF metadata standard
Index: /NEMO/trunk/doc/namelists/namsbc
===================================================================
--- /NEMO/trunk/doc/namelists/namsbc	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namsbc	(revision 11005)
@@ -2,5 +2,5 @@
 &namsbc        !   Surface Boundary Condition manager                   (default: NO selection)
 !-----------------------------------------------------------------------
-   nn_fsbc     = 5         !  frequency of SBC module call
+   nn_fsbc     = 2         !  frequency of SBC module call
       !                    !  (control sea-ice & iceberg model call)
                      ! Type of air-sea fluxes 
Index: /NEMO/trunk/doc/namelists/namthd_do
===================================================================
--- /NEMO/trunk/doc/namelists/namthd_do	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namthd_do	(revision 11005)
@@ -2,5 +2,5 @@
 &namthd_do      !   Ice growth in open water
 !------------------------------------------------------------------------------
-   rn_hinew         =   0.1           !  thickness for new ice formation in open water (m), must be larger than rn_hnewice
+   rn_hinew         =   0.1           !  thickness for new ice formation in open water (m), must be larger than rn_himin
    ln_frazil        = .false.         !  Frazil ice parameterization (ice collection as a function of wind)
       rn_maxfraz    =   1.0           !     maximum fraction of frazil ice collecting at the ice base
Index: /NEMO/trunk/doc/namelists/namthd_pnd
===================================================================
--- /NEMO/trunk/doc/namelists/namthd_pnd	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namthd_pnd	(revision 11005)
@@ -3,8 +3,7 @@
 !------------------------------------------------------------------------------
    ln_pnd_H12       = .false.         !  activate evolutive melt ponds (from Holland et al 2012)
-      ln_pnd_fwb    = .false.         !     melt ponds store freshwater or not
-   ln_pnd_CST       = .false.         !  activate constant melt ponds
-      rn_apnd       =   0.2           !     prescribed pond fraction, at Tsu=0
-      rn_hpnd       =   0.05          !     prescribed pond depth, at Tsu=0
+   ln_pnd_CST       = .false.         !  activate constant  melt ponds
+      rn_apnd       =   0.2           !     prescribed pond fraction, at Tsu=0 degC
+      rn_hpnd       =   0.05          !     prescribed pond depth,    at Tsu=0 degC
    ln_pnd_alb       = .false.         !  melt ponds affect albedo or not
 /
Index: /NEMO/trunk/doc/namelists/namthd_sal
===================================================================
--- /NEMO/trunk/doc/namelists/namthd_sal	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namthd_sal	(revision 11005)
@@ -5,10 +5,10 @@
                                       !     1: constant ice salinity (S=rn_icesal)
                                       !     2: varying salinity parameterization S(z,t)
-                                      !     3: prescribed salinity profile S(z), Schwarzacher, 1959
-   rn_icesal        =   4.            !    (nn_icesal=1) ice salinity (g/kg)
-   rn_sal_gd        =   5.            !  restoring ice salinity, gravity drainage (g/kg)
-   rn_time_gd       =   1.73e+6       !  restoring time scale, gravity drainage  (s)
-   rn_sal_fl        =   2.            !  restoring ice salinity, flushing (g/kg)
-   rn_time_fl       =   8.64e+5       !  restoring time scale, flushing (s)
+                                      !     3: prescribed salinity profile S(z) (Schwarzacher 1959)
+   rn_icesal        =   4.            !      (nn_icesal=1) ice salinity (g/kg)
+   rn_sal_gd        =   5.            !      (nn_icesal=2) restoring ice salinity, gravity drainage (g/kg)
+   rn_time_gd       =   1.73e+6       !      (nn_icesal=2) restoring time scale,   gravity drainage  (s)
+   rn_sal_fl        =   2.            !      (nn_icesal=2) restoring ice salinity, flushing (g/kg)
+   rn_time_fl       =   8.64e+5       !      (nn_icesal=2) restoring time scale,   flushing (s)
    rn_simax         =  20.            !  maximum tolerated ice salinity (g/kg)
    rn_simin         =   0.1           !  minimum tolerated ice salinity (g/kg)
Index: /NEMO/trunk/doc/namelists/namwad
===================================================================
--- /NEMO/trunk/doc/namelists/namwad	(revision 11004)
+++ /NEMO/trunk/doc/namelists/namwad	(revision 11005)
@@ -1,15 +1,15 @@
 !-----------------------------------------------------------------------
-&namwad  !   Wetting and drying
+&namwad        !   Wetting and Drying (WaD)                             (default: OFF)
 !-----------------------------------------------------------------------
-   ln_wd_il          = .false   ! T/F activation of iterative limiter for  wetting and drying scheme
-   ln_wd_dl          = .true.   ! T/F activation of directional llimiter for wetting drying scheme
-   ln_wd_dl_bc       = .true.   ! T/F Directional limiteer Baroclinic option
-   ln_wd_dl_rmp      = .true.   ! T/F Turn on directional limiter ramp
-   rn_wdmin0         =  0.30    ! dpoth at which wetting/drying starts
-   rn_wdmin1         =  0.2     ! Minimum wet depth on dried cells
-   rn_wdmin2         =  0.0001  ! Tolerance of min wet depth on dried cells
-   rn_wdld           =  2.5     ! Land elevation below which wetting/drying is allowed
-   nn_wdit           =   20     ! Max iterations for W/D limiter
-   rn_wd_sbcdep      =  5.0     ! Depth at which to taper sbc fluxes
-   rn_wd_sbcfra      =  0.999   ! Fraction of SBC fluxes at taper depth (Must be <1)
+   ln_wd_il    = .false.   !  T/F activation of iterative   limiter
+   ln_wd_dl    = .false.   !  T/F activation of directional limiter
+   ln_wd_dl_bc = .false.   !  T/F Directional limiteer Baroclinic option
+   ln_wd_dl_rmp = .false.  !  T/F Turn on directional limiter ramp
+   rn_wdmin0   =  0.30     !  depth at which WaD starts
+   rn_wdmin1   =  0.2      !  Minimum wet depth on dried cells
+   rn_wdmin2   =  0.0001   !  Tolerance of min wet depth on dried cells
+   rn_wdld     =  2.5      !  Land elevation below which WaD is allowed
+   nn_wdit     =   20      !  Max iterations for WaD limiter
+   rn_wd_sbcdep =  5.0     !  Depth at which to taper sbc fluxes
+   rn_wd_sbcfra =  0.999   !  Fraction of SBC fluxes at taper depth (Must be <1)
 /